extra_features = function(u_id, i_id, inter, users, items, type){
  
  if (type == "for_pred") { 
    
    # find indices
    u_ind = match(u_id, users$id)
    i_ind = match(i_id, items$id)
    
    # if wtcj is 1 
    wtcj = ifelse(users$wtcj[u_ind] == 1, 1, 0)
    
    # if user is a student and item is internship or part-time
    students = ((users$career_level[u_ind] == 1) & ((items$career_level[i_ind] == 1) | (items$employment[i_ind] == 1)))*1
    
    # experience years
    years_exp = ((users$experience_years_experience[u_ind] == 1) & ((items$career_level[i_ind] == 1) | (items$career_level[i_ind] == 2)))*1
    
    #  professionals and CEO won't volunteer
    CEO_volunteer = ((users$career_level[u_ind] == 5 | users$career_level[u_ind] == 6) & (items$employment[u_ind] != 5))*1
    
    # is premium
    premium = (users$premium[u_ind] == 1)*1
    
    # is payed
    is_payed = items$is_payed[i_ind]
    
    # length of region
    region_len = str_length(items$region[i_ind])
    
    # number of titles for users
    n_title_u = sapply(
      str_split(users$jobroles[u_ind], ","),
      function(x){length(x)}
    )
    # number of titles for items
    n_title_i = sapply(
      str_split(items$title[i_ind], ","), 
      function(x){length(x)}
    )
    # number of tags for items
    n_tags_i = sapply(
      str_split(items$tags[i_ind], ","), 
      function(x){length(x)}
    )
    
    result = data.frame(wtcj = wtcj,
                        students = students,
                        years_exp = years_exp,
                        CEO_volunteer = CEO_volunteer,
                        premium = premium,
                        is_paid = is_paid,
                        region_len = region_len,
                        n_title_i = n_title_i,
                        n_title_u = n_title_u,
                        n_tags_i = n_tags_i)
    
    result$sd_n_tags = (mean(result$n_tags_i) - result$n_tags_i)^2
    result$sd_n_titles = (mean(result$n_title_i) - result$n_title_i)^2
    result$sd_n_titles_u = (mean(result$n_title_u) - result$n_title_u)^2
    result$payed_premium = ifelse(result$premium == 1 & result$is_payed == 1, 1, 0)
    
    return(result)
    
  }
  
  else if (type == "for_train") {
    
    
    # find indices
    u_ind = match(inter$user_id, users$id)
    i_ind = match(inter$item_id, items$id)
    
    # if wtcj is 1 
    inter$wtcj = ifelse(users$wtcj[u_ind] == 1, 1, 0)
    
    # if user is a student and item is internship or part-time
    inter$students = ((users$career_level[u_ind] == 1) & ((items$career_level[i_ind] == 1) | (items$employment[i_ind] == 1)))*1
    
    # experience years
    inter$years_exp = ((users$experience_years_experience[u_ind] == 1) & ((items$career_level[i_ind] == 1) | (items$career_level[i_ind] == 2)))*1
    
    #  professionals and CEO won't volunteer
    inter$CEO_volounteer = (((users$career_level[u_ind] == 5) | (users$career_level[u_ind] == 6)) & (items$employment[u_ind] != 5))*1
    
    # is premium
    inter$premium = (users$premium[u_ind] == 1)*1
    
    # is payed
    inter$is_payed = items$is_payed[i_ind]
    
    # length of region
    inter$region_len = str_length(items$region[i_ind])
    
    # number of titles for users
    inter$n_title_u = sapply(
      str_split(users$jobroles[u_ind], ","),
      function(x){length(x)}
    )
    # number of titles for items
    inter$n_title_i = sapply(
      str_split(items$title[i_ind], ","),
      function(x){length(x)}
    )
    # number of tags for items
    inter$n_tags_i = sapply(
      str_split(items$tags[i_ind], ","), 
      function(x){length(x)}
    )
    
    inter$sd_n_tags = (mean(inter$n_tags_i) - inter$n_tags_i)^2
    inter$sd_n_titles = (mean(inter$n_title_i) - inter$n_title_i)^2
    inter$sd_n_titles_u = (mean(inter$n_title_u) - inter$n_title_u)^2
    inter$payed_premium = ifelse(inter$premium == 1 & inter$is_payed == 1, 1, 0)
    
    return(inter)
  }
  else {
    print("type should be a character string 'for_pred' or 'for_train'")
  }
}


str_length(items$region[8])
